## mingw-w64-gmsh-4.13.1-4.src.tar.zst

=== contrib/ANN/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2024 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file in the Gmsh root directory for license information.
# Please report all issues on https://gitlab.onelab.info/gmsh/gmsh/issues.

set(SRC
  src/ANN.cpp
  src/bd_fix_rad_search.cpp
  src/bd_pr_search.cpp
  src/bd_search.cpp
  src/bd_tree.cpp
  src/brute.cpp
  src/kd_dump.cpp
  src/kd_fix_rad_search.cpp
  src/kd_pr_search.cpp
  src/kd_search.cpp
  src/kd_split.cpp
  src/kd_tree.cpp
  src/kd_util.cpp
  src/perf.cpp
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(contrib/ANN "${SRC};${HDR}")

=== contrib/mpeg_encode/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2024 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file in the Gmsh root directory for license information.
# Please report all issues on https://gitlab.onelab.info/gmsh/gmsh/issues.

set(SRC
  bframe.cpp
  bsearch.cpp
  frame.cpp
  huff.cpp
  jrevdct.cpp
  param.cpp
  postdct.cpp
  rate.cpp
  specifics.cpp
  bitio.cpp
  combine.cpp
  frametype.cpp
  iframe.cpp
  libpnmrw.cpp
  mfwddct.cpp
  mpeg.cpp
  psearch.cpp
  readframe.cpp
  subsample.cpp
  block.cpp
  fsize.cpp
  nojpeg.cpp
  noparallel.cpp
  main.cpp
  mheaders.cpp
  opts.cpp
  pframe.cpp
  rgbtoycc.cpp
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} headers/*.h)
append_gmsh_src(contrib/mpeg_encode "${SRC};${HDR}")

=== contrib/tinyxml2/CMakeLists.txt ===
# Gmsh - Copyright (C) 1997-2024 C. Geuzaine, J.-F. Remacle
#
# See the LICENSE.txt file in the Gmsh root directory for license information.
# Please report all issues on https://gitlab.onelab.info/gmsh/gmsh/issues.

set(SRC
  tinyxml2.cpp
)

file(GLOB_RECURSE HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_gmsh_src(contrib/tinyxml2 "${SRC};${HDR}")

=== examples/api/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

# TODO: Gmsh should create a cmake file when installing the lib, so all the
# external dependencies can be obtained automatically

# if CMAKE_BUILD_TYPE is specified use it; otherwise set the default
# build type to "RelWithDebInfo" ("-O2 -g" with gcc) prior to calling
# project()
if(DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose build type")
else()
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose build type")
endif()

project(api_examples CXX C)

set(CMAKE_CXX_STANDARD 11)

find_library(GMSH_LIB gmsh)
if(NOT GMSH_LIB)
  message(FATAL_ERROR "Could not find libgmsh")
endif()

find_path(GMSH_INC gmsh.h)
if(NOT GMSH_INC)
  message(FATAL_ERROR "Could not find gmsh.h")
endif()

if(GMSH_LIB MATCHES ".a") # FIXME - generalize this
  find_library(BLAS_LIB blas)
  if(BLAS_LIB)
    list(APPEND EXTRA_LIBS ${BLAS_LIB})
  endif()
  find_library(LAPACK_LIB lapack)
  if(LAPACK_LIB)
    list(APPEND EXTRA_LIBS ${LAPACK_LIB})
  endif()
endif()

if(WIN32 OR CYGWIN)
  list(APPEND EXTRA_LIBS winmm wsock32 ws2_32 psapi)
endif()

include_directories(${GMSH_INC})

include(CTest)

file(GLOB EXAMPLES *.cpp)
foreach(EXAMPLE ${EXAMPLES})
  get_filename_component(EXAMPLENAME ${EXAMPLE} NAME_WE)
  file(STRINGS ${EXAMPLE} EXAMPLE_CONTENTS NEWLINE_CONSUME)
  string(REGEX MATCH "::fltk::" GUI ${EXAMPLE_CONTENTS})
  if(GUI)
    add_executable(${EXAMPLENAME} WIN32 MACOSX_BUNDLE ${EXAMPLE})
    if(APPLE)
      file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/${EXAMPLENAME}.plist
           "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\
            <!DOCTYPE plist PUBLIC \"-//Apple Computer//DTD PLIST 1.0//EN\"\
             \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\">\n\
            <plist version=\"1.0\">\n\
              <dict>\n\
                <key>CFBundleName</key><string>${EXAMPLENAME}</string>\n\
                <key>CFBundleExecutable</key><string>${EXAMPLENAME}</string>\n\
                <key>CFBundlePackageType</key><string>APPL</string>\n\
                <key>CFBundleVersion</key><string>1.0.0</string>\n\
                <key>CFBundleShortVersionString</key><string>1.0.0</string>\n\
                <key>CFBundleIconFile</key><string></string>\n\
                <key>CFBundleSignature</key><string>????</string>\n\
                <key>CFBundleGetInfoString</key><string></string>\n\
                <key>CFBundleIdentifier</key><string></string>\n\
                <key>NSHighResolutionCapable</key><true/>\n\
              </dict>\n\
            </plist>")
      set_target_properties(${EXAMPLENAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST
                            ${CMAKE_CURRENT_BINARY_DIR}/${EXAMPLENAME}.plist)
      add_test(${EXAMPLENAME}_cpp ${EXAMPLENAME}.app/Contents/MacOS/${EXAMPLENAME} -nopopup)
    else()
      add_test(${EXAMPLENAME}_cpp ${EXAMPLENAME} -nopopup)
    endif()
  else()
    add_executable(${EXAMPLENAME} ${EXAMPLE})
    add_test(${EXAMPLENAME}_cpp ${EXAMPLENAME} -nopopup)
  endif()
  target_link_libraries(${EXAMPLENAME} ${GMSH_LIB} ${EXTRA_LIBS})
endforeach()

file(GLOB EXAMPLES *.c)
foreach(EXAMPLE ${EXAMPLES})
  get_filename_component(EXAMPLENAME ${EXAMPLE} NAME_WE)
  add_executable(${EXAMPLENAME}c ${EXAMPLE})
  target_link_libraries(${EXAMPLENAME}c ${GMSH_LIB} ${EXTRA_LIBS})
  add_test(${EXAMPLENAME}_c ${EXAMPLENAME}c -nopopup)
endforeach()

find_program(PYTHON python3)
if(PYTHON)
  file(GLOB EXAMPLES *.py)
  foreach(EXAMPLE ${EXAMPLES})
    get_filename_component(EXAMPLENAME ${EXAMPLE} NAME_WE)
    add_test(${EXAMPLENAME}_py ${PYTHON} ${EXAMPLE} -nopopup)
  endforeach()
endif()

find_program(JULIA julia)
if(JULIA)
  file(GLOB EXAMPLES *.jl)
  foreach(EXAMPLE ${EXAMPLES})
    get_filename_component(EXAMPLENAME ${EXAMPLE} NAME_WE)
    add_test(${EXAMPLENAME}_jl ${JULIA} ${EXAMPLE} -nopopup)
  endforeach()
endif()

=== contrib/voro++/examples/basic/Makefile ===
# Voro++ makefile
#
# Author : Chris H. Rycroft (LBL / UC Berkeley)
# Email  : chr@alum.mit.edu
# Date   : August 30th 2011

# Load the common configuration file
include ../../config.mk

# List of executables
EXECUTABLES=single_cell platonic random_points import

# Makefile rules
all: $(EXECUTABLES)

single_cell: single_cell.cc
	$(CXX) $(CFLAGS) $(E_INC) $(E_LIB) -o single_cell single_cell.cc -lvoro++

platonic: platonic.cc
	$(CXX) $(CFLAGS) $(E_INC) $(E_LIB) -o platonic platonic.cc -lvoro++

random_points: random_points.cc
	$(CXX) $(CFLAGS) $(E_INC) $(E_LIB) -o random_points random_points.cc -lvoro++

import: import.cc
	$(CXX) $(CFLAGS) $(E_INC) $(E_LIB) -o import import.cc -lvoro++

clean:
	rm -f $(EXECUTABLES)

.PHONY: all clean

=== PKGBUILD ===
# Maintainer: ImperatorS79 <fevrier.simon@gmail.com>

_realname=gmsh
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=4.13.1
pkgrel=4
pkgdesc="3D finite element mesh generator with built-in CAD engine and post-processor (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url="https://gmsh.info"
msys2_repository_url="https://gitlab.onelab.info/gmsh/gmsh/"
license=("spdx:GPL-2.0-or-later")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-petsc"
             "${MINGW_PACKAGE_PREFIX}-slepc")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-fltk"
         "${MINGW_PACKAGE_PREFIX}-gmp"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-med"
         "${MINGW_PACKAGE_PREFIX}-opencascade"
         "${MINGW_PACKAGE_PREFIX}-zlib")
source=(https://gmsh.info/src/gmsh-${pkgver}-source.tgz
        0001-fix-link-lib-name.patch
        0002-fix-dynamic-linking.patch
        0003-fltk-1.4.patch::https://gitlab.onelab.info/gmsh/gmsh/-/commit/3b3f0f7e16430939b345889a9e31b50104d5baf3.patch)
sha256sums=('77972145f431726026d50596a6a44fb3c1c95c21255218d66955806b86edbe8d'
            'e575ae8fc757694affb6749dc9d52c336691b06159845655ef2ac27aebae8159'
            '4d3f5c4190529e3d45b786adab83f0d65e726357d7367f682ff95b733a88a8c3'
            'f06d4ce2d45b640531d4556fb3fa41741903a4b27a2f28b1d3a1a82be77a42d0')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}/gmsh-${pkgver}-source"

  apply_patch_with_msg \
    0001-fix-link-lib-name.patch \
    0002-fix-dynamic-linking.patch \
    0003-fltk-1.4.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  CFLAGS+=" -Wno-implicit-function-declaration" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DENABLE_BUILD_DYNAMIC=ON \
      -DENABLE_BUILD_SHARED=ON \
      -DENABLE_CAIRO=ON \
      -DENABLE_OCC=ON \
      -DENABLE_OPENMP=ON \
      -DENABLE_OPENACC=ON \
      -DENABLE_PETSC=ON \
      -DENABLE_SLEPC=ON \
      -DGMSH_RELEASE=ON \
      ../gmsh-${pkgver}-source

  "${MINGW_PREFIX}"/bin/cmake --build .
}

check () {
  cd "${srcdir}/build-${MSYSTEM}"
  "${MINGW_PREFIX}"/bin/ctest .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake --install .

  mv "${pkgdir}${MINGW_PREFIX}"/lib/*.dll "${pkgdir}${MINGW_PREFIX}"/bin/
}
